<%
/**
 * type定義文字列を生成する
 *
 * @param object propertie
 *      swaggerのpropertie定義
 * @param string | null targetRef
 *      swaggerのtype定義がされている$ref
 *      定義内に$refがあった場合に参照の仕方が変わってくる("module.typename" or "typename")
 *      ex)"#/components/responses/"
 * @param object options
 *      オプション
 * @param boolean options.oneline
 *      定義を一行で生成する
 */
const oneline = options.oneline || false
-%>
<% if ((propertie.type === "number" || propertie.type === "integer") && propertie.enum) {
    // enum number
    %>(<%- propertie.enum.join(" | ")  %>)<%
} else if (propertie.type === "number" || propertie.type === "integer") {
    // number
    %>number<%
} else if (propertie.type === "string" && propertie.enum) {
    // enum string
    %>(<%- propertie.enum.map(e => `'${e}'`).join(" | ")  %>)<%
} else if (propertie.type === "string") {
    // string
    %>string<%
} else if (propertie.type === "boolean") {
    // boolean
    %>boolean<%
} else if (propertie.type === "object") {
    // object
    const object = propertie
    const propertiesCodes = Object.getOwnPropertyNames(object.properties).map(propertieName => {
        const propertie = object.properties[propertieName]
        const optional = object.required && !object.required.includes(propertieName)
        return (oneline ?  "" : include('./propertie-description.ejs', {propertie})) + // プロパティ説明
                _.name.camel(propertieName) + (optional ? "?: " : ": ") + include('./index.ejs', {propertie, targetRef, oneline}) // プロパティ定義
    })

    if (oneline) {
        %><%- "{ " + propertiesCodes.join(", ") + " }" %><%
    } else {
        const addIndentOptions = {
            indentStr: '  ',
            nonIndentEmptyLine: true
        }
        %><%- "{\n" + _.code.addIndent(propertiesCodes.join("\n\n"), addIndentOptions) + "\n}" %><%
    }
} else if (propertie.type === "array") {
    // array
    %><%- include('./index.ejs', {propertie: propertie.items, targetRef}) %>[]<%
} else if (propertie.oneOf) {
    // |
    %>(<%- propertie.oneOf.map(p => include('./index.ejs', {propertie: p, targetRef})).join(" | ") %>)<%
} else if (propertie.allOf) {
    // &
    %>(<%- propertie.allOf.map(p => include('./index.ejs', {propertie: p, targetRef})).join(" & ") %>)<%
} else if (propertie.$ref && propertie.$ref.startsWith('#/components/')) {
    // $ref
    const s = propertie.$ref.split("/")
    let type
    if (s.length === 4) {
        type = targetRef && propertie.$ref.startsWith(targetRef) ? s[3] /* 同じファイル内の定義 */ : `${s[2]}.${s[3]}` /* 異なるファイルの定義 */
    } else {
        // 循環参照の問題があるが、いいアイデアがないので保留
        type = include('./index.ejs', {propertie: _.swagger.resolveRef($, propertie.$ref), targetRef})
    }
    %><%- type %><%
} else  {
    // unknown
    %>unknown<%
}
    // nullable
    %><% if (propertie.nullable) {%> | null<% } %>